#include "Thread.h"

#include "radioGroup.h"
#include "runtime.h"

#include <utility.h>  
#include "CCD.h"
#include "Atmcd32d.h"
#include <analysis.h>
#include <ansi_c.h>
#include "scanner.h"
#include "CCDControl.h"

#include "DLL6K.h"
#include "grating_focus.h"
#include "FISS.h"
#include "scanner.h"

#include <userint.h>     
#include "TalkClientDLL.h"


#include "Mmsystem.h"
#pragma comment(lib, "winmm.lib");

extern int take;
extern int Scanpos_CCDframe;


//panel  
extern int mainPanel;       //HANDLE OF MAIN PANEL( г ڵ)
extern int FISSpanelSetting; 
extern int testpanel;
extern int TabPanelHandle;			//handle of tab panel     
extern int	aboutPanel; 
extern int menubar;
extern int GraphicPanel;


extern int 	temp_thread, temp_thread_id;  
int Run_thread_stop=1;  //1: stop 


extern long 	nCameraHandle1;		//camera handle1
extern long 	nCameraHandle2;		//camera handle2

extern	LARGE_INTEGER gliFreq, gliStart, gliEnd;
extern WORD* 			g_pRawData;			//allocated data dumped real data
extern int			nhDim1,nvDim1,nhDim2,nvDim2;  
extern int				CCD_status;
extern int Scanner_status; 
extern int 	g_nFrameNumber1;//, g_nNumberKinetics1;    
extern int		ccd_camera;  
extern int		sequential_number;     
extern float 	g_fExpTime1, g_fExpTime2;			//exposure time     
extern char entire_directory[250];   

extern int 	fiss_take_mode; 
extern int  Scanner_InPosition;
extern float	scanpos;
extern WvSet Data[50];
extern float *flatdata1;
extern float *flatcube1;
extern WORD*			BiasDark1;
extern WORD*			BiasDark2;
extern int DataSource;
extern long 	nUnknownCameraHandle;

int program_off_temp_set=0;


int CVICALLBACK setTempThread(void* functionData)
{
	int errorValue1,errorValue2;
	int CCDTemp1, CCDTemp2;
	int i=0;
	char buffer[100];

	char CCDTempStr[100];

	SetCtrlVal(mainPanel,PANEL_CCDTEMPSTATUS, 0);   
	while(!temp_thread)
	{
		SetCurrentCamera(nCameraHandle1);
		errorValue1=GetTemperature(&CCDTemp1);
	
		errorValue2=Lan_GetTemperature(&CCDTemp2);
		sprintf(buffer,"CCD1: %d C CCD2: %d C\n", CCDTemp1,CCDTemp2); 
		SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,buffer); 
		if((errorValue1!=DRV_TEMP_STABILIZED) || (errorValue2!=DRV_TEMP_STABILIZED))
		{
				Delay(1);
				
				errorValue1=GetTemperature(&CCDTemp1);
				
				errorValue2=Lan_GetTemperature(&CCDTemp2);
				sprintf(buffer,"CCD1: %d C CCD2: %d C\n", CCDTemp1,CCDTemp2);
				//SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,buffer);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,buffer);
				
				sprintf(CCDTempStr, "%d %cC", CCDTemp1,176);
				
				SetCtrlVal(mainPanel, PANEL_CCD1TEMP,CCDTempStr);
				sprintf(CCDTempStr, "%d %cC", CCDTemp2, 176); 
				SetCtrlVal(mainPanel, PANEL_CCD2TEMP,CCDTempStr);
		}
		else
		{
			
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Temperature Stabilized!\n");
			SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"Temperature Stabilized!\n"); 
			SetCtrlVal(mainPanel,PANEL_CCDTEMPSTATUS, 1);
			temp_thread=1; 
		}
	}
	return 0;
}




int CVICALLBACK RunThread(void* functionData)
{
	int 			i;
	char 			temp[50],temp1[50],temp2[50],temp3[50],temp4[50];
	unsigned short 	minvalue,maxvalue;
	int				ccd_acqmode; //ccd acquisition mode(single, video, frame transfer)
	float diff_time1,diff_time2;
	int				ii,j,k,startpoint1,startpoint2;
	int				flatstart1,flatstart2;

	int				id,handle;
	int 	threadfunctionID; 
	DWORD 	startt, endt;
	char 	strt[10];
	char str[100];
	
	int attr_top, attr_width, attr_left;
	SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
	SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);
	Run_thread_stop=0; 
	if ((GraphicPanel = LoadPanel (0, "FISS.uir", GRAPHICPNL)) < 0)
								return -1;
	GetPanelAttribute(mainPanel, ATTR_TOP, &attr_top);
	GetPanelAttribute(mainPanel, ATTR_WIDTH, &attr_width);
	GetPanelAttribute(mainPanel, ATTR_LEFT, &attr_left);
	
	SetPanelAttribute(GraphicPanel, ATTR_TOP, attr_top); 
	SetPanelAttribute(GraphicPanel, ATTR_LEFT, attr_left+attr_width+7);
	DisplayPanel(GraphicPanel);


					

	GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
	GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setAcq, &ccd_acqmode);
			
	if(!QueryPerformanceFrequency(&gliFreq))
		MessagePopup("Error","Cannot support the timer of high resolution");
			
	SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
	SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);
	
	SetCtrlAttribute(mainPanel, PANEL_SelectAxis,			ATTR_DIMMED,1);
	SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame,		ATTR_DIMMED,1);		
	SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN,			ATTR_DIMMED,1);
	SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX,			ATTR_DIMMED,1);		
	SetCtrlAttribute(mainPanel, PANEL_GRAPH,				ATTR_DIMMED,1);	
			
	
		if(g_nFrameNumber1==1)	  //single mode ,    1 .
		{													      //ܼ single mode
						
					if(ccd_camera==2 || ccd_camera==3)				   //both mode
					{
							for(i=0;i<sequential_number;i++)
							{
								startt=timeGetTime();  
								if(Run_thread_stop)break; 
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  								
								Lan_memset_RawData2(nhDim2*nvDim2*sizeof(WORD));  								
								
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								
								//SetCurrentCamera(nCameraHandle2);
								Lan_OnGrab();
								
								
								
								marktime_start(temp1);
								//SetCurrentCamera(nCameraHandle1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();


								
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								Lan_SaveFits(g_nFrameNumber1);
								endt=timeGetTime();
								sprintf(strt,"%.1f",(float)(endt-startt)*0.001);
								SetCtrlVal(mainPanel, PANEL_info10,strt);						
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							  
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
							SetCurrentCamera(nCameraHandle1);
							
							SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
					}
						

					else if (ccd_camera==0)		//ccd1, nCameraHandle1					  //use single camera
					{
							SetCurrentCamera(nCameraHandle1);
							for(i=0;i<sequential_number;i++)
							{
								startt=timeGetTime();  
								if(Run_thread_stop)break; 
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								marktime_start(temp1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();

								//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								endt=timeGetTime();
								sprintf(strt,"%.1f",(float)(endt-startt)*0.001);
								SetCtrlVal(mainPanel, PANEL_info10,strt);								
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);	
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);
					}
						
					else if(ccd_camera==1)		//ccd2, nCameraHandle2
					{
						
							for(i=0;i<sequential_number;i++)
							{
								startt=timeGetTime(); 
								if(Run_thread_stop)break; 
								Lan_memset_RawData2(nhDim2*nvDim2*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
									
								
								TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
								
								
								
								Lan_SaveFits(g_nFrameNumber1);
										
								endt=timeGetTime();
								sprintf(strt,"%.1f",(float)(endt-startt)*0.001);
								SetCtrlVal(mainPanel, PANEL_info10,strt);
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							 
							DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
						
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
					}						
		}			
			

		if((g_nFrameNumber1 == 0) || (ccd_acqmode==0))      //video(focus) mode
		{															 // ,  ȭ鿡  ϱ⿡ thread Ѵ.
					Run_thread_stop=0;
					Lan_Run_thread_stop(0);	
					GetCurrentCamera(&nUnknownCameraHandle);
					while(!Run_thread_stop)
					{
							if(nUnknownCameraHandle==nCameraHandle1)
								{
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								DisplayCCDImage(nhDim1, nvDim1, 1, nCameraHandle1);
								
							}
							if(nUnknownCameraHandle==nCameraHandle2)
							{
								TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
								DisplayCCDImage(nhDim2, nvDim2, 1, nCameraHandle2);
							}
					}
					
		}	
	
				
			
				
				//Most Important Part!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		if((g_nFrameNumber1 >1) && (ccd_acqmode!=6) &&(ccd_acqmode!=8))		// CCD Scanner Ǿ  κ.
		{

					
						if(ccd_camera==2)		   //both mode, sequentially operate e.g scanning-CCD1 complete-->scanning-CCD2 complete
						{   
								for(i=0;i<sequential_number;i++)
								{
									startt=timeGetTime(); 
									if(Run_thread_stop)break; 
									memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
									Lan_memset_RawData2(nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
									sprintf(temp,"%d",i+1);
									SetCtrlVal(mainPanel,PANEL_S1,temp);
									fiss_take_mode=0;
									do
									{
									}while(!((scanpos<6) && (scanpos>-6) && (Scanner_InPosition==1))) ;								
							
									marktime_start(temp1);
									//SetCurrentCamera(nCameraHandle1);
									ExecuteProgram(nCameraHandle1,0);
									marktime_end(temp2);
									diff_time1=time_difference();

									do
									{
									}while(!((scanpos<6) && (scanpos>-6) && (Scanner_InPosition==1))) ;
					

								
									//SetCurrentCamera(nCameraHandle2);
									ExecuteProgram(nCameraHandle2,0);	
								
								
									SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
									Lan_SaveFits(g_nFrameNumber1);								
									//SetCurrentCamera(nCameraHandle1);
									Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);  	  
									Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue,nCameraHandle1);
									endt=timeGetTime();
									sprintf(strt,"%.1f",(float)(endt-startt)*0.001);
									SetCtrlVal(mainPanel, PANEL_info10,strt);
								}
								//after for loop, present image.
								//SetCurrentCamera(nCameraHandle1);
								DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
								SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
								SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}
					
							
						else if(ccd_camera==3)		  //both mode that we must use
						{
								for(i=0;i<sequential_number;i++)
								{
									startt=timeGetTime();   
									if(Run_thread_stop)break; 
									memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
									
									Lan_memset_RawData2(nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
								
									sprintf(temp,"%d",i+1);
									SetCtrlVal(mainPanel,PANEL_S1,temp);
							
									fiss_take_mode=1;
									do
									{
									}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;
								
									marktime_start(temp1);
									//SetCurrentCamera(nCameraHandle1);
									ExecuteProgram(nCameraHandle1,1);
									marktime_end(temp2);
									diff_time1=time_difference();
								
									SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
									Lan_SaveFits(g_nFrameNumber1);								
									//SetCurrentCamera(nCameraHandle1);
									Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);
									Display3D_CCD(1,260,&minvalue,&maxvalue,nCameraHandle1);
									endt=timeGetTime();
									sprintf(strt,"%.1f",(float)(endt-startt)*0.001);
									SetCtrlVal(mainPanel, PANEL_info10,strt);
									
								}
								//SetCurrentCamera(nCameraHandle1);
								DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
								SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
								SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}
							

						else if(ccd_camera==0)				//ccd1,nCameraHandle1			 //single camera
						{  
							fiss_take_mode=0;
							SetCurrentCamera(nCameraHandle1);
							for(i=0;i<sequential_number;i++) 
							{
								if(Run_thread_stop)break; 
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								do
								{
								}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;	
							
								marktime_start(temp1);
								ExecuteProgram(nCameraHandle1,0);
								marktime_end(temp2);
								diff_time1=time_difference();
							
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
							  	
								Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue, nCameraHandle1);
											 						
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 		
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);
						}
					
						else if(ccd_camera==1)		   //ccd2, nCameraHandle2
						{
							fiss_take_mode=0;
							SetCurrentCamera(nCameraHandle2);
							for(i=0;i<sequential_number;i++) 
							{
								if(Run_thread_stop)break; 
								Lan_memset_RawData2(nhDim2*nvDim2*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								do
								{
								}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;	
							
								marktime_start(temp1);
								ExecuteProgram(nCameraHandle2,0);
								marktime_end(temp2);
								diff_time1=time_difference();
							
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								
								Display3D_CCD(1,nhDim2/2,&minvalue,&maxvalue, nCameraHandle2); 							
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2); 	
							SetCurrentCamera(nCameraHandle2);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}
						else if(ccd_camera==4)		 //flat fileding, important!!!		  --> move to CCD.c (TakingFlat)
						{
							MessagePopup("","Error");
						}
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 0); //undim Frame Slide 
					SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 0); //undim Frame Slide         
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, 0);						
		}
		

		
		
		if((g_nFrameNumber1 >1) && (ccd_acqmode==6))			   //frame transfer mode
		{
				for(i=0;i<sequential_number;i++)
				{
					sprintf(temp,"%d",i+1);
					SetCtrlVal(mainPanel,PANEL_S1,temp);
					sprintf(temp,"%d",i);							

					if(ccd_camera==0)	//ccd1
					{
						memset(g_pRawData ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));
						marktime_start(temp1);
						TakeImage_FTmode(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
						marktime_end(temp2);
						diff_time1=time_difference();
								
						//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
						SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
						DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
						//Sleep(1000);
						SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
						SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
					}

					if(ccd_camera==1)	//ccd2
					{
						Lan_memset_RawData2(nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));

						marktime_start(temp1);
						TakeImage_FTmode(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
						marktime_end(temp2);
						diff_time1=time_difference();

						//BiasDarkCorrection(nhDim2,nvDim2,nCameraHandle2,g_nFrameNumber1-1);
						SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
						DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
						SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
						SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
					}
							
					if(ccd_camera==3 || ccd_camera==2) //two ccd taking simultaneously
					{
						memset(g_pRawData ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));
						Lan_memset_RawData2(nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD)); 
								
						SetCurrentCamera(nCameraHandle1);
						marktime_start(temp1);
						TakeImage_FTmode(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
						marktime_end(temp2);
						diff_time1=time_difference();
								
						SetCurrentCamera(nCameraHandle2);
						marktime_start(temp3);
						TakeImage_FTmode(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
						marktime_end(temp4);
						diff_time2=time_difference();
								
								
						//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
						SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
						SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								
						DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
						//Sleep(1000);
						SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
						SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);								
					}
							
								
				}  //sequential loop
				
		}
		
		if((g_nFrameNumber1 >1) && (ccd_acqmode==8))	  //scan stop, operate only CCD at fix position
		{
			//printf("scan stop mode!!!\n");
			//PmacAccessible=0; //turn off MonitoringThread Function
////////////////			
/*						if(ccd_camera==2)		   //both mode, sequentially operate e.g scanning-CCD1 complete-->scanning-CCD2 complete
						{   
								for(i=0;i<sequential_number;i++)
								{
									if(Run_thread_stop)break; 
									memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
									memset(g_pRawData2 ,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
									sprintf(temp,"%d",i+1);
									SetCtrlVal(mainPanel,PANEL_S1,temp);
								//	fiss_take_mode=0;
								//	do
								//	{
								//	}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;								
							
									marktime_start(temp1);
									SetCurrentCamera(nCameraHandle1);
									
									for(j=0;j<g_nFrameNumber1;j++)
									{
										TakeImage(nhDim1,nvDim1,nCameraHandle1,j);
									}
									
									
									//ExecuteProgram(nCameraHandle1,0);
									marktime_end(temp2);
									diff_time1=time_difference();

								//	do
								//	{
								//	}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;
					

									marktime_start(temp3);
									SetCurrentCamera(nCameraHandle2);
									
									for(j=0;j<g_nFrameNumber1;j++)
									{
										TakeImage(nhDim2,nvDim2,nCameraHandle2,j);
									}
							
									//ExecuteProgram(nCameraHandle2,0);	
									marktime_end(temp4);
									diff_time2=time_difference();
								
									SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
									SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp3, temp4, diff_time2, entire_directory);								
									SetCurrentCamera(nCameraHandle1);
									Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);  	  
									Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue,nCameraHandle1);
								}
								//after for loop, present image.
								SetCurrentCamera(nCameraHandle1);
								DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
								SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
								SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}
					
							
						else if(ccd_camera==3)		  //both mode that we must use
						{
								for(i=0;i<sequential_number;i++)
								{
									if(Run_thread_stop)break; 
									memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
									memset(g_pRawData2 ,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
									sprintf(temp,"%d",i+1);
									SetCtrlVal(mainPanel,PANEL_S1,temp);
							
								//	fiss_take_mode=1;
								//	do
								//	{
								//	}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;
								
									marktime_start(temp1);
									//SetCurrentCamera(nCameraHandle1);
									
									
									for(j=0;j<g_nFrameNumber1;j++)
									{
										SetCurrentCamera(nCameraHandle1);
										TakeImage(nhDim1,nvDim1,nCameraHandle1,j);
										SetCurrentCamera(nCameraHandle2);
										TakeImage(nhDim2,nvDim2,nCameraHandle2,j);
									}
									
									
									//ExecuteProgram(nCameraHandle1,1);
									marktime_end(temp2);
									diff_time1=time_difference();
								
									SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
									SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);								
									SetCurrentCamera(nCameraHandle1);
									Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							  
									Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue,nCameraHandle1);
								}
								SetCurrentCamera(nCameraHandle1);
								DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
								SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
								SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
								SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}

*/						

						if(ccd_camera==0)				//ccd1,nCameraHandle1			 //single camera
						{  
							//printf("ccd 1\n");
							fiss_take_mode=0;
							SetCurrentCamera(nCameraHandle1);
							for(i=0;i<sequential_number;i++) 
							{
								if(Run_thread_stop)break; 
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								marktime_start(temp1);
								//ExecuteProgram(nCameraHandle1,0);
								
								for(j=0;j<g_nFrameNumber1;j++)
								{
									 //Scanpos_CCDframe=j+1;
									 //take=1;
									 //Sleep(g_fExpTime1*1000);
									TakeImage(nhDim1,nvDim1,nCameraHandle1,j);
								}
								
								marktime_end(temp2);
								diff_time1=time_difference();
							
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
								Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue, nCameraHandle1);
											 						
							}
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 		
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);
						}
					
/*
						else if(ccd_camera==1)		   //ccd2, nCameraHandle2
						{
							//fiss_take_mode=0;
							SetCurrentCamera(nCameraHandle2);
							for(i=0;i<sequential_number;i++) 
							{
								if(Run_thread_stop)break; 
								memset(g_pRawData2  ,0,nhDim2*nvDim2*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
							//	do
							//	{
							//	}while(!((scanpos<1) && (scanpos>-1) && (Scanner_InPosition==1))) ;	
							
								marktime_start(temp1);
								
								for(j=0;j<g_nFrameNumber1;j++)
								{
									TakeImage(nhDim2,nvDim2,nCameraHandle2,j);
								}
								
								//ExecuteProgram(nCameraHandle2,0);
								marktime_end(temp2);
								diff_time1=time_difference();
							
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime2, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								
								Display3D_CCD(1,nhDim2/2,&minvalue,&maxvalue, nCameraHandle2); 							
							}
							

						    Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2); 	
							SetCurrentCamera(nCameraHandle2);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
							SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
						}
						else if(ccd_camera==4)		 //flat fileding, important!!!		  --> move to CCD.c (TakingFlat)
						{
							MessagePopup("","Error");
						}
						
*/						
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 0); //undim Frame Slide 
					SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 0); //undim Frame Slide         
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, 0);						
					
			
////////////////			
		}
			
			
			
			DataSource=1;
			//PmacAccessible=1;

	Run_thread_stop=1;
	Lan_Run_thread_stop(1);
	DiscardPanel(GraphicPanel);
	GraphicPanel=0;
	
	
	return 0;
}




void CVICALLBACK AfterRunThread(int poolHandle, int functionID, unsigned int event, int value, void *callbackData)
{
		
}

