#include "idltools.h"
#include <userint.h>

static void CVIFUNC _DIDLDrawX3EventsRegOnReadyStateChange_EventVTableFunc (void *thisPtr);

static void CVIFUNC _DIDLDrawX3EventsRegOnDblClick_EventVTableFunc (void *thisPtr);

static void CVIFUNC _DIDLDrawX3EventsRegOnKeyDown_EventVTableFunc (void *thisPtr,
                                                                   short *keyCode,
                                                                   short shift);

static void CVIFUNC _DIDLDrawX3EventsRegOnClick_EventVTableFunc (void *thisPtr);

static void CVIFUNC _DIDLDrawX3EventsRegOnKeyPress_EventVTableFunc (void *thisPtr,
                                                                    short *keyAscii);

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseDown_EventVTableFunc (void *thisPtr,
                                                                     short button,
                                                                     short shift,
                                                                     long x,
                                                                     long y);

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseMove_EventVTableFunc (void *thisPtr,
                                                                     short button,
                                                                     short shift,
                                                                     long x,
                                                                     long y);

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseUp_EventVTableFunc (void *thisPtr,
                                                                   short button,
                                                                   short shift,
                                                                   long x,
                                                                   long y);

#define __ActiveXCtrlErrorHandler() \
if ((ctrlId) > 0) \
	{ \
	if (controlID) \
		*controlID = (ctrlId); \
	if (UILError) \
		*UILError = 0; \
	__result = S_OK; \
	} \
else if ((ctrlId) == UIEActiveXError) \
	{ \
	if (controlID) \
		*controlID = 0; \
	if (UILError) \
		*UILError = 0; \
	} \
else \
	{ \
	if (controlID) \
		*controlID = 0; \
	if (UILError) \
		*UILError = (ctrlId); \
	__result = E_CVIAUTO_CVI_UI_ERROR; \
	}

typedef interface tagIDL_IIDLDrawX3_Interface IDL_IIDLDrawX3_Interface;

typedef struct tagIDL_IIDLDrawX3_VTable
{
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( IDL_IIDLDrawX3_Interface __RPC_FAR * This, 
	                                                         REFIID riid, 
	                                                         void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( IDL_IIDLDrawX3_Interface __RPC_FAR * This);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( IDL_IIDLDrawX3_Interface __RPC_FAR * This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount )( IDL_IIDLDrawX3_Interface __RPC_FAR * This, 
	                                                           UINT __RPC_FAR *pctinfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo )( IDL_IIDLDrawX3_Interface __RPC_FAR * This, 
	                                                      UINT iTInfo, 
	                                                      LCID lcid, 
	                                                      ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames )( IDL_IIDLDrawX3_Interface __RPC_FAR * This, 
	                                                        REFIID riid, 
	                                                        LPOLESTR __RPC_FAR *rgszNames, 
	                                                        UINT cNames, 
	                                                        LCID lcid, 
	                                                        DISPID __RPC_FAR *rgDispId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Invoke )( IDL_IIDLDrawX3_Interface __RPC_FAR * This, 
	                                                 DISPID dispIdMember, 
	                                                 REFIID riid, 
	                                                 LCID lcid, 
	                                                 WORD wFlags, 
	                                                 DISPPARAMS __RPC_FAR *pDispParams, 
	                                                 VARIANT __RPC_FAR *pVarResult, 
	                                                 EXCEPINFO __RPC_FAR *pExcepInfo, 
	                                                 UINT __RPC_FAR *puArgErr);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetReadyState_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                        long *lReadyState);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GethWnd_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                  long *ohhWnd);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBorderStyle_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                         short sBorderStyle);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetBorderStyle_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                         short *sBorderStyle);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBackColor_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       unsigned long pocColor);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetBackColor_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       unsigned long *pocColor);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetEnable_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    VBOOL pbEnable);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetEnable_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    VBOOL *pbEnable);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnButtonPress_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                           BSTR bstOnButtonPress);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnButtonPress_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                           BSTR *bstOnButtonPress);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnButtonRelease_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                             BSTR bstOnButtonRelease);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnButtonRelease_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                             BSTR *bstOnButtonRelease);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnMotion_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR bstOnMotion);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnMotion_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR *bstOnMotion);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnInit_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    BSTR bstOnInit);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnInit_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    BSTR *bstOnInit);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnExpose_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR bstOnExpose);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnExpose_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR *bstOnExpose);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBaseName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR bstBaseName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetBaseName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      BSTR *bstBaseName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetDrawWidgetName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                            BSTR bstDrawWidgetName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDrawWidgetName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                            BSTR *bstDrawWidgetName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetGetValueName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                          BSTR bstGetValueName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGetValueName_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                          BSTR *bstGetValueName);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetXsize_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                   long lXsize);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetXsize_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                   long *lXsize);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetYsize_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                   long lYsize);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetYsize_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                   long *lYsize);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetXoffset_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     long lXoffset);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetXoffset_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     long *lXoffset);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetYoffset_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     long lYoffset);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetYoffset_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     long *lYoffset);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetScroll_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    VBOOL bScroll);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetScroll_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    VBOOL *bScroll);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetRetain_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    short sRetain);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetRetain_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    short *sRetain);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetGraphicsLevel_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                           short sGraphicsLevel);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGraphicsLevel_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                           short *sGraphicsLevel);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDrawId_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    long *lDrawId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetBaseId_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    long *lBaseId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOnDblClick_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                        BSTR bstOnDblClick);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetOnDblClick_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                        BSTR *bstOnDblClick);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetIdlPath_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     BSTR bstIdlPath);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetIdlPath_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     BSTR *bstIdlPath);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetXviewport_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       long xviewport);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetXviewport_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       long *xviewport);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetYviewport_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       long yviewport);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetYviewport_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       long *yviewport);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetVisible_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     VBOOL bVisible);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetVisible_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     VBOOL *bVisible);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetRenderer_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      short sRenderer);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetRenderer_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      short *sRenderer);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetLastIdlError_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                          BSTR *bstError);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetBufferId_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      long plBuffId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetBufferId_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                      long *plBuffId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *InitIDL_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                  long hWndMain, 
	                                                  long *lInited);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetOutputWnd_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       long hWndLog, 
	                                                       long *lRet);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetNamedData_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       BSTR strName, 
	                                                       VARIANT *vREt);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ExecuteStr_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     BSTR strCommand, 
	                                                     long *lErr);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *CreateDrawWidget_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                           long *lDrawId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetNamedData_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       BSTR strName, 
	                                                       VARIANT vData, 
	                                                       short *sRet);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetNamedArray_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                        BSTR strName, 
	                                                        VARIANT vData, 
	                                                        VBOOL bDestroyOnFree, 
	                                                        short *sRet);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DoExit_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DestroyDrawWidget_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DoButtonPress_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                        short nButton, 
	                                                        short x, 
	                                                        short y);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DoButtonRelease_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                          short nButton, 
	                                                          short x, 
	                                                          short y);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DoMotion_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                   short nButton, 
	                                                   short x, 
	                                                   short y);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *DoExpose_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *RegisterForEvents_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                            long lEvents, 
	                                                            VBOOL *bVal);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *CopyNamedArray_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                         BSTR strName, 
	                                                         VARIANT *vArray);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *CopyWindow_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                     VBOOL *bCopied);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Print_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                long lXoffset, 
	                                                long lYoffset, 
	                                                long lWidth, 
	                                                long lHeight, 
	                                                VBOOL *bPrinted);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *PrintPreview_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                       VBOOL *bPrinted);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *InitStringInfo_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                         BSTR strInfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *VariableExists_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                         BSTR strName, 
	                                                         VBOOL *bExists);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *InitIDLEx_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This, 
	                                                    long hWndMain, 
	                                                    long lFlags, 
	                                                    long *lInited);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Refresh_) (IDL_IIDLDrawX3_Interface __RPC_FAR *This);

} IDL_IIDLDrawX3_VTable;

typedef interface tagIDL_IIDLDrawX3_Interface
{
	CONST_VTBL IDL_IIDLDrawX3_VTable __RPC_FAR *lpVtbl;
} IDL_IIDLDrawX3_Interface;

static CA_PARAMDATA __DIDLDrawX3Events_RegOnKeyDown_CA_PARAMDATA[] =
	{
		{"keyCode", VT_I2 | VT_BYREF},
        {"shift", VT_I2}
	};

static CA_PARAMDATA __DIDLDrawX3Events_RegOnKeyPress_CA_PARAMDATA[] =
	{
		{"keyAscii", VT_I2 | VT_BYREF}
	};

static CA_PARAMDATA __DIDLDrawX3Events_RegOnMouseDown_CA_PARAMDATA[] =
	{
		{"button", VT_I2},
        {"shift", VT_I2},
        {"x", VT_I4},
        {"y", VT_I4}
	};

static CA_PARAMDATA __DIDLDrawX3Events_RegOnMouseMove_CA_PARAMDATA[] =
	{
		{"button", VT_I2},
        {"shift", VT_I2},
        {"x", VT_I4},
        {"y", VT_I4}
	};

static CA_PARAMDATA __DIDLDrawX3Events_RegOnMouseUp_CA_PARAMDATA[] =
	{
		{"button", VT_I2},
        {"shift", VT_I2},
        {"x", VT_I4},
        {"y", VT_I4}
	};

static CA_METHODDATA __DIDLDrawX3Events_CA_METHODDATA[] =
	{
		{"ReadyStateChange", NULL, -609, 0, CC_STDCALL, 0, DISPATCH_METHOD, VT_EMPTY},
        {"DblClick", NULL, -601, 1, CC_STDCALL, 0, DISPATCH_METHOD, VT_EMPTY},
        {"KeyDown", __DIDLDrawX3Events_RegOnKeyDown_CA_PARAMDATA, -602, 2, CC_STDCALL, 2, DISPATCH_METHOD, VT_EMPTY},
        {"Click", NULL, -600, 3, CC_STDCALL, 0, DISPATCH_METHOD, VT_EMPTY},
        {"KeyPress", __DIDLDrawX3Events_RegOnKeyPress_CA_PARAMDATA, -603, 4, CC_STDCALL, 1, DISPATCH_METHOD, VT_EMPTY},
        {"MouseDown", __DIDLDrawX3Events_RegOnMouseDown_CA_PARAMDATA, -605, 5, CC_STDCALL, 4, DISPATCH_METHOD, VT_EMPTY},
        {"MouseMove", __DIDLDrawX3Events_RegOnMouseMove_CA_PARAMDATA, -606, 6, CC_STDCALL, 4, DISPATCH_METHOD, VT_EMPTY},
        {"MouseUp", __DIDLDrawX3Events_RegOnMouseUp_CA_PARAMDATA, -607, 7, CC_STDCALL, 4, DISPATCH_METHOD, VT_EMPTY}
	};

static CA_INTERFACEDATA __DIDLDrawX3Events_CA_INTERFACEDATA =
	{
		__DIDLDrawX3Events_CA_METHODDATA,
        sizeof (__DIDLDrawX3Events_CA_METHODDATA) / sizeof (*__DIDLDrawX3Events_CA_METHODDATA)
	};

static void * __DIDLDrawX3Events_EventVTable[] =
	{
		_DIDLDrawX3EventsRegOnReadyStateChange_EventVTableFunc,
        _DIDLDrawX3EventsRegOnDblClick_EventVTableFunc,
        _DIDLDrawX3EventsRegOnKeyDown_EventVTableFunc,
        _DIDLDrawX3EventsRegOnClick_EventVTableFunc,
        _DIDLDrawX3EventsRegOnKeyPress_EventVTableFunc,
        _DIDLDrawX3EventsRegOnMouseDown_EventVTableFunc,
        _DIDLDrawX3EventsRegOnMouseMove_EventVTableFunc,
        _DIDLDrawX3EventsRegOnMouseUp_EventVTableFunc
	};

static CAEventClassDefn __DIDLDrawX3Events_CAEventClassDefn =
	{
		20,
        &IDL_IID__DIDLDrawX3Events,
        __DIDLDrawX3Events_EventVTable,
        &__DIDLDrawX3Events_CA_INTERFACEDATA,
        0
	};

const IID IDL_IID__DIDLDrawX3 =
	{
		0xA7397363, 0x5A93, 0x11D5, 0xBC, 0x2F, 0x0, 0x50, 0xDA, 0xCD, 0x1B, 0x91
	};

const IID IDL_IID_IIDLDrawX3 =
	{
		0xA7397362, 0x5A93, 0x11D5, 0xBC, 0x2F, 0x0, 0x50, 0xDA, 0xCD, 0x1B, 0x91
	};

const IID IDL_IID__DIDLDrawX3Events =
	{
		0xA7397364, 0x5A93, 0x11D5, 0xBC, 0x2F, 0x0, 0x50, 0xDA, 0xCD, 0x1B, 0x91
	};

HRESULT CVIFUNC IDL_New_DIDLDrawX3 (int panel, const char *label, int top,
                                    int left, int *controlID, int *UILError)
{
	HRESULT __result = S_OK;
	int ctrlId;
	GUID clsid = {0xA7397365, 0x5A93, 0x11D5, 0xBC, 0x2F, 0x0, 0x50, 0xDA,
	              0xCD, 0x1B, 0x91};
	const char * licStr = NULL;

	ctrlId = NewActiveXCtrl (panel, label, top, left, &clsid,
	                         &IDL_IID__DIDLDrawX3, licStr, &__result);

	__ActiveXCtrlErrorHandler();

	return __result;
}

HRESULT CVIFUNC IDL_Open_DIDLDrawX3 (const char *fileName, int panel,
                                     const char *label, int top, int left,
                                     int *controlID, int *UILError)
{
	HRESULT __result = S_OK;
	int ctrlId;

	ctrlId = NewActiveXCtrlFromFile (panel, label, top, left, fileName,
	                                 &IDL_IID__DIDLDrawX3, &__result);

	__ActiveXCtrlErrorHandler();

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3InitIDL (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long hWndMain,
                                        long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1A, CAVT_LONG,
	                              returnValue, 1, __paramTypes, hWndMain);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOutputWnd (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long hWndLog,
                                             long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1B, CAVT_LONG,
	                              returnValue, 1, __paramTypes, hWndLog);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetNamedData (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName,
                                             VARIANT *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1C, CAVT_VARIANT,
	                              returnValue, 1, __paramTypes, strName);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3ExecuteStr (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *strCommand,
                                           long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1D, CAVT_LONG,
	                              returnValue, 1, __paramTypes, strCommand);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3CreateDrawWidget (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1E, CAVT_LONG,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetNamedData (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName, VARIANT vData,
                                             short *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_VARIANT};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1F, CAVT_SHORT,
	                              returnValue, 2, __paramTypes, strName, vData);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetNamedArray (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName, VARIANT vData,
                                              VBOOL bDestroyOnFree,
                                              short *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING, CAVT_VARIANT, CAVT_BOOL};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x20, CAVT_SHORT,
	                              returnValue, 3, __paramTypes, strName, vData,
	                              bDestroyOnFree);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DoExit (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x21, CAVT_EMPTY, NULL,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DestroyDrawWidget (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x22, CAVT_EMPTY, NULL,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DoButtonPress (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short nButton, short x, short y)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT, CAVT_SHORT, CAVT_SHORT};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x23, CAVT_EMPTY, NULL,
	                              3, __paramTypes, nButton, x, y);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DoButtonRelease (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short nButton, short x, short y)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT, CAVT_SHORT, CAVT_SHORT};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x24, CAVT_EMPTY, NULL,
	                              3, __paramTypes, nButton, x, y);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DoMotion (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short nButton,
                                         short x, short y)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT, CAVT_SHORT, CAVT_SHORT};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x25, CAVT_EMPTY, NULL,
	                              3, __paramTypes, nButton, x, y);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3DoExpose (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x26, CAVT_EMPTY, NULL,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3RegisterForEvents (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long lEvents,
                                                  VBOOL *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x27, CAVT_BOOL,
	                              returnValue, 1, __paramTypes, lEvents);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3CopyNamedArray (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strName,
                                               VARIANT *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x28, CAVT_VARIANT,
	                              returnValue, 1, __paramTypes, strName);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3CopyWindow (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x29, CAVT_BOOL,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3Print (CAObjHandle objectHandle,
                                      ERRORINFO *errorInfo, long lXoffset,
                                      long lYoffset, long lWidth, long lHeight,
                                      VBOOL *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG, CAVT_LONG, CAVT_LONG, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2A, CAVT_BOOL,
	                              returnValue, 4, __paramTypes, lXoffset,
	                              lYoffset, lWidth, lHeight);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3PrintPreview (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             VBOOL *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2B, CAVT_BOOL,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3InitStringInfo (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strInfo)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2C, CAVT_EMPTY, NULL,
	                              1, __paramTypes, strInfo);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3VariableExists (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strVarName,
                                               VBOOL *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2D, CAVT_BOOL,
	                              returnValue, 1, __paramTypes, strVarName);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3InitIDLEx (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long hWndMain,
                                          long lFlags, long *returnValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG, CAVT_LONG};

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2E, CAVT_LONG,
	                              returnValue, 2, __paramTypes, hWndMain,
	                              lFlags);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3Refresh (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDDA, CAVT_EMPTY,
	                              NULL, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3AboutBox (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;

	__result = CA_MethodInvokeEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDD8, CAVT_EMPTY,
	                              NULL, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetReadyState (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDF3,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GethWnd (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo,
                                        IDLType_OLE_HANDLE *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFD,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SethWnd (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo,
                                        IDLType_OLE_HANDLE newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFD,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefhWnd (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_HANDLE *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFD,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetBorderStyle (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE08,
	                              DISPATCH_PROPERTYGET, CAVT_SHORT,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetBorderStyle (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE08,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBorderStyle (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE08,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetBackColor (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_COLOR *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE0B,
	                              DISPATCH_PROPERTYGET, CAVT_ULONG,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetBackColor (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_COLOR newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_ULONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE0B,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBackColor (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  IDLType_OLE_COLOR *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_ULONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFE0B,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetEnabled (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFE,
	                              DISPATCH_PROPERTYGET, CAVT_BOOL, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetEnabled (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFE,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefEnabled (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                VBOOL *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xFFFFFDFE,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnButtonPress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnButtonPress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnButtonPress (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x1,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnButtonRelease (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnButtonRelease (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnButtonRelease (CAObjHandle objectHandle,
                                                        ERRORINFO *errorInfo,
                                                        char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x2,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnMotion (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x3,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnMotion (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x3,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnMotion (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x3,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnInit (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x4,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnInit (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x4,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnInit (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x4,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnExpose (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x5,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnExpose (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x5,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnExpose (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x5,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetBaseName (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x6,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetBaseName (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x6,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBaseName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x6,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetDrawWidgetName (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x7,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetDrawWidgetName (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x7,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefDrawWidgetName (CAObjHandle objectHandle,
                                                       ERRORINFO *errorInfo,
                                                       char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x7,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetGetValueName (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x8,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetGetValueName (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x8,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefGetValueName (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x8,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetXsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x9,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetXsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x9,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXsize (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x9,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetYsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xA,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetYsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xA,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYsize (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xA,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetXoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xB,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetXoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xB,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXoffset (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xB,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetYoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xC,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetYoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xC,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYoffset (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xC,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetScroll (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          VBOOL *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xD,
	                              DISPATCH_PROPERTYGET, CAVT_BOOL, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetScroll (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xD,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefScroll (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               VBOOL *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xD,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetRetain (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          short *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xE,
	                              DISPATCH_PROPERTYGET, CAVT_SHORT,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetRetain (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, short newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xE,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefRetain (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xE,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetGraphicsLevel (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xF,
	                              DISPATCH_PROPERTYGET, CAVT_SHORT,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetGraphicsLevel (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xF,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefGraphicsLevel (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0xF,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetDrawId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x10,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetDrawId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x10,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefDrawId (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x10,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetBaseId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x11,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetBaseId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x11,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBaseId (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x11,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnDblClick (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x12,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnDblClick (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x12,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnDblClick (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x12,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetIdlPath (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x13,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetIdlPath (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x13,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefIdlPath (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x13,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetXviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x14,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetXviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x14,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXviewport (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x14,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetYviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x15,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetYviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x15,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYviewport (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x15,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetVisible (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x16,
	                              DISPATCH_PROPERTYGET, CAVT_BOOL, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetVisible (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x16,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefVisible (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                VBOOL *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_BOOL | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x16,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetRenderer (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            short *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x17,
	                              DISPATCH_PROPERTYGET, CAVT_SHORT,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetRenderer (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x17,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefRenderer (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_SHORT | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x17,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetLastIdlError (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x18,
	                              DISPATCH_PROPERTYGET, CAVT_CSTRING,
	                              returnValue, 0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetLastIdlError (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x18,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefLastIdlError (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     char **newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_CSTRING | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x18,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3GetBufferId (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *returnValue)
{
	HRESULT __result = S_OK;

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x19,
	                              DISPATCH_PROPERTYGET, CAVT_LONG, returnValue,
	                              0, NULL);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetBufferId (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x19,
	                              DISPATCH_PROPERTYPUT, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBufferId (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long *newValue)
{
	HRESULT __result = S_OK;
	unsigned int __paramTypes[] = {CAVT_LONG | CAVT_BYREFI};

	__result = CA_InvokeHelperEx (objectHandle, errorInfo,
	                              &IDL_IID__DIDLDrawX3, 0x19,
	                              DISPATCH_PROPERTYPUTREF, CAVT_EMPTY, NULL, 1,
	                              __paramTypes, newValue);

	return __result;
}

HRESULT CVIFUNC IDL_NewIIDLDrawX3 (int panel, const char *label, int top,
                                   int left, int *controlID, int *UILError)
{
	HRESULT __result = S_OK;
	int ctrlId;
	GUID clsid = {0xA7397365, 0x5A93, 0x11D5, 0xBC, 0x2F, 0x0, 0x50, 0xDA,
	              0xCD, 0x1B, 0x91};
	const char * licStr = NULL;

	ctrlId = NewActiveXCtrl (panel, label, top, left, &clsid,
	                         &IDL_IID_IIDLDrawX3, licStr, &__result);

	__ActiveXCtrlErrorHandler();

	return __result;
}

HRESULT CVIFUNC IDL_OpenIIDLDrawX3 (const char *fileName, int panel,
                                    const char *label, int top, int left,
                                    int *controlID, int *UILError)
{
	HRESULT __result = S_OK;
	int ctrlId;

	ctrlId = NewActiveXCtrlFromFile (panel, label, top, left, fileName,
	                                 &IDL_IID_IIDLDrawX3, &__result);

	__ActiveXCtrlErrorHandler();

	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetReadyState (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *lReadyState)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lReadyState__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetReadyState_ (__vtblIFacePtr,
	                                                    &lReadyState__Temp));

	if (lReadyState)
		{
		*lReadyState = lReadyState__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GethWnd (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo,
                                       IDLType_OLE_HANDLE *ohhWnd)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long ohhWnd__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GethWnd_ (__vtblIFacePtr,
	                                              &ohhWnd__Temp));

	if (ohhWnd)
		{
		*ohhWnd = ohhWnd__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetBorderStyle (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short sBorderStyle)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetBorderStyle_ (__vtblIFacePtr,
	                                                     sBorderStyle));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetBorderStyle (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short *sBorderStyle)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short sBorderStyle__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetBorderStyle_ (__vtblIFacePtr,
	                                                     &sBorderStyle__Temp));

	if (sBorderStyle)
		{
		*sBorderStyle = sBorderStyle__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetBackColor (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            IDLType_OLE_COLOR pocColor)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetBackColor_ (__vtblIFacePtr,
	                                                   pocColor));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetBackColor (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            IDLType_OLE_COLOR *pocColor)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned long pocColor__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetBackColor_ (__vtblIFacePtr,
	                                                   &pocColor__Temp));

	if (pocColor)
		{
		*pocColor = pocColor__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetEnable (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL pbEnable)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetEnable_ (__vtblIFacePtr, pbEnable));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetEnable (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL *pbEnable)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL pbEnable__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetEnable_ (__vtblIFacePtr,
	                                                &pbEnable__Temp));

	if (pbEnable)
		{
		*pbEnable = pbEnable__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnButtonPress (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *bstOnButtonPress)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnButtonPress__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnButtonPress,
	                              &bstOnButtonPress__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnButtonPress_ (__vtblIFacePtr,
	                                                       bstOnButtonPress__AutoType));

Error:
	CA_FreeBSTR (bstOnButtonPress__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnButtonPress (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **bstOnButtonPress)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnButtonPress__AutoType = 0;

	if (bstOnButtonPress)
		*bstOnButtonPress = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnButtonPress_ (__vtblIFacePtr,
	                                                       &bstOnButtonPress__AutoType));

	if (bstOnButtonPress)
		__caErrChk (CA_BSTRGetCString (bstOnButtonPress__AutoType,
	                               bstOnButtonPress));

Error:
	CA_FreeBSTR (bstOnButtonPress__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnButtonPress)
			{
			CA_FreeMemory (*bstOnButtonPress);
			*bstOnButtonPress = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnButtonRelease (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  const char *bstOnButtonRelease)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnButtonRelease__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnButtonRelease,
	                              &bstOnButtonRelease__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnButtonRelease_ (__vtblIFacePtr,
	                                                         bstOnButtonRelease__AutoType));

Error:
	CA_FreeBSTR (bstOnButtonRelease__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnButtonRelease (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  char **bstOnButtonRelease)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnButtonRelease__AutoType = 0;

	if (bstOnButtonRelease)
		*bstOnButtonRelease = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnButtonRelease_ (__vtblIFacePtr,
	                                                         &bstOnButtonRelease__AutoType));

	if (bstOnButtonRelease)
		__caErrChk (CA_BSTRGetCString (bstOnButtonRelease__AutoType,
	                               bstOnButtonRelease));

Error:
	CA_FreeBSTR (bstOnButtonRelease__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnButtonRelease)
			{
			CA_FreeMemory (*bstOnButtonRelease);
			*bstOnButtonRelease = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnMotion (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstOnMotion)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnMotion__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnMotion, &bstOnMotion__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnMotion_ (__vtblIFacePtr,
	                                                  bstOnMotion__AutoType));

Error:
	CA_FreeBSTR (bstOnMotion__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnMotion (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstOnMotion)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnMotion__AutoType = 0;

	if (bstOnMotion)
		*bstOnMotion = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnMotion_ (__vtblIFacePtr,
	                                                  &bstOnMotion__AutoType));

	if (bstOnMotion)
		__caErrChk (CA_BSTRGetCString (bstOnMotion__AutoType, bstOnMotion));

Error:
	CA_FreeBSTR (bstOnMotion__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnMotion)
			{
			CA_FreeMemory (*bstOnMotion);
			*bstOnMotion = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnInit (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo,
                                         const char *bstOnInit)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnInit__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnInit, &bstOnInit__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnInit_ (__vtblIFacePtr,
	                                                bstOnInit__AutoType));

Error:
	CA_FreeBSTR (bstOnInit__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnInit (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, char **bstOnInit)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnInit__AutoType = 0;

	if (bstOnInit)
		*bstOnInit = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnInit_ (__vtblIFacePtr,
	                                                &bstOnInit__AutoType));

	if (bstOnInit)
		__caErrChk (CA_BSTRGetCString (bstOnInit__AutoType, bstOnInit));

Error:
	CA_FreeBSTR (bstOnInit__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnInit)
			{
			CA_FreeMemory (*bstOnInit);
			*bstOnInit = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnExpose (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstOnExpose)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnExpose__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnExpose, &bstOnExpose__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnExpose_ (__vtblIFacePtr,
	                                                  bstOnExpose__AutoType));

Error:
	CA_FreeBSTR (bstOnExpose__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnExpose (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstOnExpose)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnExpose__AutoType = 0;

	if (bstOnExpose)
		*bstOnExpose = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnExpose_ (__vtblIFacePtr,
	                                                  &bstOnExpose__AutoType));

	if (bstOnExpose)
		__caErrChk (CA_BSTRGetCString (bstOnExpose__AutoType, bstOnExpose));

Error:
	CA_FreeBSTR (bstOnExpose__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnExpose)
			{
			CA_FreeMemory (*bstOnExpose);
			*bstOnExpose = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetBaseName (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstBaseName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstBaseName__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstBaseName, &bstBaseName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetBaseName_ (__vtblIFacePtr,
	                                                  bstBaseName__AutoType));

Error:
	CA_FreeBSTR (bstBaseName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetBaseName (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstBaseName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstBaseName__AutoType = 0;

	if (bstBaseName)
		*bstBaseName = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetBaseName_ (__vtblIFacePtr,
	                                                  &bstBaseName__AutoType));

	if (bstBaseName)
		__caErrChk (CA_BSTRGetCString (bstBaseName__AutoType, bstBaseName));

Error:
	CA_FreeBSTR (bstBaseName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstBaseName)
			{
			CA_FreeMemory (*bstBaseName);
			*bstBaseName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetDrawWidgetName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 const char *bstDrawWidgetName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstDrawWidgetName__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstDrawWidgetName,
	                              &bstDrawWidgetName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetDrawWidgetName_ (__vtblIFacePtr,
	                                                        bstDrawWidgetName__AutoType));

Error:
	CA_FreeBSTR (bstDrawWidgetName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetDrawWidgetName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **bstDrawWidgetName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstDrawWidgetName__AutoType = 0;

	if (bstDrawWidgetName)
		*bstDrawWidgetName = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetDrawWidgetName_ (__vtblIFacePtr,
	                                                        &bstDrawWidgetName__AutoType));

	if (bstDrawWidgetName)
		__caErrChk (CA_BSTRGetCString (bstDrawWidgetName__AutoType,
	                               bstDrawWidgetName));

Error:
	CA_FreeBSTR (bstDrawWidgetName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstDrawWidgetName)
			{
			CA_FreeMemory (*bstDrawWidgetName);
			*bstDrawWidgetName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetGetValueName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *bstGetValueName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstGetValueName__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstGetValueName, &bstGetValueName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetGetValueName_ (__vtblIFacePtr,
	                                                      bstGetValueName__AutoType));

Error:
	CA_FreeBSTR (bstGetValueName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetGetValueName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **bstGetValueName)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstGetValueName__AutoType = 0;

	if (bstGetValueName)
		*bstGetValueName = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGetValueName_ (__vtblIFacePtr,
	                                                      &bstGetValueName__AutoType));

	if (bstGetValueName)
		__caErrChk (CA_BSTRGetCString (bstGetValueName__AutoType, bstGetValueName));

Error:
	CA_FreeBSTR (bstGetValueName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstGetValueName)
			{
			CA_FreeMemory (*bstGetValueName);
			*bstGetValueName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetXsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long lXsize)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetXsize_ (__vtblIFacePtr, lXsize));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetXsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long *lXsize)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lXsize__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetXsize_ (__vtblIFacePtr,
	                                               &lXsize__Temp));

	if (lXsize)
		{
		*lXsize = lXsize__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetYsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long lYsize)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetYsize_ (__vtblIFacePtr, lYsize));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetYsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long *lYsize)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lYsize__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetYsize_ (__vtblIFacePtr,
	                                               &lYsize__Temp));

	if (lYsize)
		{
		*lYsize = lYsize__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetXoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long lXoffset)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetXoffset_ (__vtblIFacePtr, lXoffset));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetXoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long *lXoffset)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lXoffset__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetXoffset_ (__vtblIFacePtr,
	                                                 &lXoffset__Temp));

	if (lXoffset)
		{
		*lXoffset = lXoffset__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetYoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long lYoffset)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetYoffset_ (__vtblIFacePtr, lYoffset));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetYoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long *lYoffset)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lYoffset__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetYoffset_ (__vtblIFacePtr,
	                                                 &lYoffset__Temp));

	if (lYoffset)
		{
		*lYoffset = lYoffset__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetScroll (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL bScroll)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetScroll_ (__vtblIFacePtr, bScroll));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetScroll (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL *bScroll)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bScroll__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetScroll_ (__vtblIFacePtr,
	                                                &bScroll__Temp));

	if (bScroll)
		{
		*bScroll = bScroll__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetRetain (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short sRetain)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetRetain_ (__vtblIFacePtr, sRetain));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetRetain (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short *sRetain)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short sRetain__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetRetain_ (__vtblIFacePtr,
	                                                &sRetain__Temp));

	if (sRetain)
		{
		*sRetain = sRetain__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetGraphicsLevel (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short sGraphicsLevel)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetGraphicsLevel_ (__vtblIFacePtr,
	                                                       sGraphicsLevel));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetGraphicsLevel (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short *sGraphicsLevel)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short sGraphicsLevel__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGraphicsLevel_ (__vtblIFacePtr,
	                                                       &sGraphicsLevel__Temp));

	if (sGraphicsLevel)
		{
		*sGraphicsLevel = sGraphicsLevel__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetDrawId (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *lDrawId)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lDrawId__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetDrawId_ (__vtblIFacePtr,
	                                                &lDrawId__Temp));

	if (lDrawId)
		{
		*lDrawId = lDrawId__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetBaseId (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *lBaseId)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lBaseId__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetBaseId_ (__vtblIFacePtr,
	                                                &lBaseId__Temp));

	if (lBaseId)
		{
		*lBaseId = lBaseId__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnDblClick (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *bstOnDblClick)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnDblClick__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstOnDblClick, &bstOnDblClick__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOnDblClick_ (__vtblIFacePtr,
	                                                    bstOnDblClick__AutoType));

Error:
	CA_FreeBSTR (bstOnDblClick__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnDblClick (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             char **bstOnDblClick)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstOnDblClick__AutoType = 0;

	if (bstOnDblClick)
		*bstOnDblClick = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetOnDblClick_ (__vtblIFacePtr,
	                                                    &bstOnDblClick__AutoType));

	if (bstOnDblClick)
		__caErrChk (CA_BSTRGetCString (bstOnDblClick__AutoType, bstOnDblClick));

Error:
	CA_FreeBSTR (bstOnDblClick__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstOnDblClick)
			{
			CA_FreeMemory (*bstOnDblClick);
			*bstOnDblClick = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetIdlPath (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *bstIdlPath)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstIdlPath__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (bstIdlPath, &bstIdlPath__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetIdlPath_ (__vtblIFacePtr,
	                                                 bstIdlPath__AutoType));

Error:
	CA_FreeBSTR (bstIdlPath__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetIdlPath (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          char **bstIdlPath)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstIdlPath__AutoType = 0;

	if (bstIdlPath)
		*bstIdlPath = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetIdlPath_ (__vtblIFacePtr,
	                                                 &bstIdlPath__AutoType));

	if (bstIdlPath)
		__caErrChk (CA_BSTRGetCString (bstIdlPath__AutoType, bstIdlPath));

Error:
	CA_FreeBSTR (bstIdlPath__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstIdlPath)
			{
			CA_FreeMemory (*bstIdlPath);
			*bstIdlPath = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetXviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long xviewport)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetXviewport_ (__vtblIFacePtr,
	                                                   xviewport));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetXviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *xviewport)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long xviewport__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetXviewport_ (__vtblIFacePtr,
	                                                   &xviewport__Temp));

	if (xviewport)
		{
		*xviewport = xviewport__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetYviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long yviewport)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetYviewport_ (__vtblIFacePtr,
	                                                   yviewport));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetYviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *yviewport)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long yviewport__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetYviewport_ (__vtblIFacePtr,
	                                                   &yviewport__Temp));

	if (yviewport)
		{
		*yviewport = yviewport__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetVisible (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL bVisible)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetVisible_ (__vtblIFacePtr, bVisible));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetVisible (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL *bVisible)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bVisible__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetVisible_ (__vtblIFacePtr,
	                                                 &bVisible__Temp));

	if (bVisible)
		{
		*bVisible = bVisible__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetRenderer (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, short sRenderer)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetRenderer_ (__vtblIFacePtr,
	                                                  sRenderer));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetRenderer (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           short *sRenderer)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short sRenderer__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetRenderer_ (__vtblIFacePtr,
	                                                  &sRenderer__Temp));

	if (sRenderer)
		{
		*sRenderer = sRenderer__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetLastIdlError (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **bstError)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR bstError__AutoType = 0;

	if (bstError)
		*bstError = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetLastIdlError_ (__vtblIFacePtr,
	                                                      &bstError__AutoType));

	if (bstError)
		__caErrChk (CA_BSTRGetCString (bstError__AutoType, bstError));

Error:
	CA_FreeBSTR (bstError__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (bstError)
			{
			CA_FreeMemory (*bstError);
			*bstError = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetBufferId (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long plBuffId)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetBufferId_ (__vtblIFacePtr, plBuffId));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetBufferId (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long *plBuffId)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long plBuffId__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetBufferId_ (__vtblIFacePtr,
	                                                  &plBuffId__Temp));

	if (plBuffId)
		{
		*plBuffId = plBuffId__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3InitIDL (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo, long hWndMain,
                                       long *lInited)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lInited__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->InitIDL_ (__vtblIFacePtr, hWndMain,
	                                              &lInited__Temp));

	if (lInited)
		{
		*lInited = lInited__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetOutputWnd (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long hWndLog,
                                            long *lRet)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lRet__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetOutputWnd_ (__vtblIFacePtr, hWndLog,
	                                                   &lRet__Temp));

	if (lRet)
		{
		*lRet = lRet__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3GetNamedData (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *strName, VARIANT *vREt)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strName__AutoType = 0;
	VARIANT vREt__Temp;

	if (vREt)
		CA_VariantSetEmpty (vREt);
	CA_VariantSetEmpty (&vREt__Temp);

	__caErrChk (CA_CStringToBSTR (strName, &strName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetNamedData_ (__vtblIFacePtr,
	                                                   strName__AutoType,
	                                                   &vREt__Temp));

	if (vREt)
		{
		*vREt = vREt__Temp;
		CA_VariantSetEmpty (&vREt__Temp);
		}

Error:
	CA_FreeBSTR (strName__AutoType);
	CA_VariantClear (&vREt__Temp);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (vREt)
			CA_VariantClear (vREt);
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3ExecuteStr (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *strCommand, long *lErr)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strCommand__AutoType = 0;
	long lErr__Temp;

	__caErrChk (CA_CStringToBSTR (strCommand, &strCommand__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ExecuteStr_ (__vtblIFacePtr,
	                                                 strCommand__AutoType,
	                                                 &lErr__Temp));

	if (lErr)
		{
		*lErr = lErr__Temp;
		}

Error:
	CA_FreeBSTR (strCommand__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3CreateDrawWidget (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *lDrawId)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lDrawId__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->CreateDrawWidget_ (__vtblIFacePtr,
	                                                       &lDrawId__Temp));

	if (lDrawId)
		{
		*lDrawId = lDrawId__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetNamedData (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *strName, VARIANT vData,
                                            short *sRet)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strName__AutoType = 0;
	short sRet__Temp;

	__caErrChk (CA_CStringToBSTR (strName, &strName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetNamedData_ (__vtblIFacePtr,
	                                                   strName__AutoType,
	                                                   vData, &sRet__Temp));

	if (sRet)
		{
		*sRet = sRet__Temp;
		}

Error:
	CA_FreeBSTR (strName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3SetNamedArray (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName, VARIANT vData,
                                             VBOOL bDestroyOnFree, short *sRet)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strName__AutoType = 0;
	short sRet__Temp;

	__caErrChk (CA_CStringToBSTR (strName, &strName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetNamedArray_ (__vtblIFacePtr,
	                                                    strName__AutoType,
	                                                    vData, bDestroyOnFree,
	                                                    &sRet__Temp));

	if (sRet)
		{
		*sRet = sRet__Temp;
		}

Error:
	CA_FreeBSTR (strName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DoExit (CAObjHandle objectHandle,
                                      ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DoExit_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DestroyDrawWidget (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DestroyDrawWidget_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DoButtonPress (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, short nButton,
                                             short x, short y)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DoButtonPress_ (__vtblIFacePtr,
	                                                    nButton, x, y));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DoButtonRelease (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short nButton, short x, short y)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DoButtonRelease_ (__vtblIFacePtr,
	                                                      nButton, x, y));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DoMotion (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, short nButton,
                                        short x, short y)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DoMotion_ (__vtblIFacePtr, nButton, x,
	                                               y));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3DoExpose (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->DoExpose_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3RegisterForEvents (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long lEvents, VBOOL *bVal)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bVal__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->RegisterForEvents_ (__vtblIFacePtr,
	                                                        lEvents,
	                                                        &bVal__Temp));

	if (bVal)
		{
		*bVal = bVal__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3CopyNamedArray (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName,
                                              VARIANT *vArray)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strName__AutoType = 0;
	VARIANT vArray__Temp;

	if (vArray)
		CA_VariantSetEmpty (vArray);
	CA_VariantSetEmpty (&vArray__Temp);

	__caErrChk (CA_CStringToBSTR (strName, &strName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->CopyNamedArray_ (__vtblIFacePtr,
	                                                     strName__AutoType,
	                                                     &vArray__Temp));

	if (vArray)
		{
		*vArray = vArray__Temp;
		CA_VariantSetEmpty (&vArray__Temp);
		}

Error:
	CA_FreeBSTR (strName__AutoType);
	CA_VariantClear (&vArray__Temp);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (vArray)
			CA_VariantClear (vArray);
		}
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3CopyWindow (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL *bCopied)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bCopied__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->CopyWindow_ (__vtblIFacePtr,
	                                                 &bCopied__Temp));

	if (bCopied)
		{
		*bCopied = bCopied__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3Print (CAObjHandle objectHandle,
                                     ERRORINFO *errorInfo, long lXoffset,
                                     long lYoffset, long lWidth, long lHeight,
                                     VBOOL *bPrinted)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bPrinted__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Print_ (__vtblIFacePtr, lXoffset,
	                                            lYoffset, lWidth, lHeight,
	                                            &bPrinted__Temp));

	if (bPrinted)
		{
		*bPrinted = bPrinted__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3PrintPreview (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            VBOOL *bPrinted)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL bPrinted__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->PrintPreview_ (__vtblIFacePtr,
	                                                   &bPrinted__Temp));

	if (bPrinted)
		{
		*bPrinted = bPrinted__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3InitStringInfo (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strInfo)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strInfo__AutoType = 0;

	__caErrChk (CA_CStringToBSTR (strInfo, &strInfo__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->InitStringInfo_ (__vtblIFacePtr,
	                                                     strInfo__AutoType));

Error:
	CA_FreeBSTR (strInfo__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3VariableExists (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName,
                                              VBOOL *bExists)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR strName__AutoType = 0;
	VBOOL bExists__Temp;

	__caErrChk (CA_CStringToBSTR (strName, &strName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->VariableExists_ (__vtblIFacePtr,
	                                                     strName__AutoType,
	                                                     &bExists__Temp));

	if (bExists)
		{
		*bExists = bExists__Temp;
		}

Error:
	CA_FreeBSTR (strName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3InitIDLEx (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long hWndMain,
                                         long lFlags, long *lInited)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	long lInited__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->InitIDLEx_ (__vtblIFacePtr, hWndMain,
	                                                lFlags, &lInited__Temp));

	if (lInited)
		{
		*lInited = lInited__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC IDL_IIDLDrawX3Refresh (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	IDL_IIDLDrawX3_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &IDL_IID_IIDLDrawX3, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Refresh_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &IDL_IID_IIDLDrawX3, __result, errorInfo,
	                    &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnReadyStateChange_EventVTableFunc (void *thisPtr)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnReadyStateChange_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 0, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnDblClick_EventVTableFunc (void *thisPtr)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnDblClick_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 1, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnKeyDown_EventVTableFunc (void *thisPtr,
                                                                   short *keyCode,
                                                                   short shift)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnKeyDown_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 2, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, keyCode, shift);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnClick_EventVTableFunc (void *thisPtr)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnClick_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 3, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnKeyPress_EventVTableFunc (void *thisPtr,
                                                                    short *keyAscii)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnKeyPress_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 4, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, keyAscii);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseDown_EventVTableFunc (void *thisPtr,
                                                                     short button,
                                                                     short shift,
                                                                     long x,
                                                                     long y)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnMouseDown_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 5, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, button, shift,
		                               x, y);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseMove_EventVTableFunc (void *thisPtr,
                                                                     short button,
                                                                     short shift,
                                                                     long x,
                                                                     long y)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnMouseMove_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 6, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, button, shift,
		                               x, y);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

static void CVIFUNC _DIDLDrawX3EventsRegOnMouseUp_EventVTableFunc (void *thisPtr,
                                                                   short button,
                                                                   short shift,
                                                                   long x,
                                                                   long y)
{
	HRESULT __result = S_OK;
	void * __callbackData;
	CAObjHandle __serverObjHandle;
	_DIDLDrawX3EventsRegOnMouseUp_CallbackType __callbackFunction;
	
	

	__caErrChk (CA_GetEventCallback (thisPtr, 7, &__callbackFunction,
	                                 &__callbackData, &__serverObjHandle));

	if (__callbackFunction != NULL)
		{
	
		__result = __callbackFunction (__serverObjHandle, __callbackData, button, shift,
		                               x, y);
	
		__caErrChk (__result);
		
		}
Error:

	return;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnReadyStateChange (CAObjHandle serverObject,
                                                            _DIDLDrawX3EventsRegOnReadyStateChange_CallbackType callbackFunction,
                                                            void *callbackData,
                                                            int enableCallbacks,
                                                            int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     0, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnDblClick (CAObjHandle serverObject,
                                                    _DIDLDrawX3EventsRegOnDblClick_CallbackType callbackFunction,
                                                    void *callbackData,
                                                    int enableCallbacks,
                                                    int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     1, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnKeyDown (CAObjHandle serverObject,
                                                   _DIDLDrawX3EventsRegOnKeyDown_CallbackType callbackFunction,
                                                   void *callbackData,
                                                   int enableCallbacks,
                                                   int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     2, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnClick (CAObjHandle serverObject,
                                                 _DIDLDrawX3EventsRegOnClick_CallbackType callbackFunction,
                                                 void *callbackData,
                                                 int enableCallbacks,
                                                 int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     3, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnKeyPress (CAObjHandle serverObject,
                                                    _DIDLDrawX3EventsRegOnKeyPress_CallbackType callbackFunction,
                                                    void *callbackData,
                                                    int enableCallbacks,
                                                    int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     4, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseDown (CAObjHandle serverObject,
                                                     _DIDLDrawX3EventsRegOnMouseDown_CallbackType callbackFunction,
                                                     void *callbackData,
                                                     int enableCallbacks,
                                                     int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     5, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseMove (CAObjHandle serverObject,
                                                     _DIDLDrawX3EventsRegOnMouseMove_CallbackType callbackFunction,
                                                     void *callbackData,
                                                     int enableCallbacks,
                                                     int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     6, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseUp (CAObjHandle serverObject,
                                                   _DIDLDrawX3EventsRegOnMouseUp_CallbackType callbackFunction,
                                                   void *callbackData,
                                                   int enableCallbacks,
                                                   int *callbackId)
{
	HRESULT __result = S_OK;

	__result = CA_RegisterEventCallback (serverObject,
	                                     &__DIDLDrawX3Events_CAEventClassDefn,
	                                     7, callbackFunction, callbackData,
	                                     enableCallbacks, callbackId);

	return __result;
}
