#include <ansi_c.h>
#include "graphic.h"
#include "FISS.h"
extern int GraphicPanel;
extern int mainPanel;


int OpenGraphicPanel(int count, int width, int height, int* rgb, char * image)
{
	int bitmapid;
	int attr_top, attr_width, attr_left;    
	
	
	GetPanelAttribute(mainPanel, ATTR_TOP, &attr_top);
	GetPanelAttribute(mainPanel, ATTR_WIDTH, &attr_width);
	GetPanelAttribute(mainPanel, ATTR_LEFT, &attr_left);
	
	SetPanelAttribute(GraphicPanel, ATTR_TOP, attr_top); 
	SetPanelAttribute(GraphicPanel, ATTR_LEFT, attr_left+attr_width+7);
	
	
	SetPanelSize(GraphicPanel,height, width); 
	SetCtrlAttribute(GraphicPanel, GRAPHICPNL_PIC_WINDOW, ATTR_WIDTH,  width);
	SetCtrlAttribute(GraphicPanel, GRAPHICPNL_PIC_WINDOW, ATTR_HEIGHT, height); 
	
	NewBitmap(width, count, width,
				height, (int*)rgb, (char*)image, NULL, &bitmapid);  
	
	SetCtrlBitmap(GraphicPanel, GRAPHICPNL_PIC_WINDOW,0,bitmapid);
	
	
	DiscardBitmap(bitmapid);
	free(image); 
	return 1;
}


int MagnetMoving(int tpanel,int eventData2)
{
	int attr_main_top, attr_main_left, attr_main_width,  attr_main_right;
	int attr_left, attr_width, attr_top, attr_right;
	int magnet_region;
	Rect cRect;
	
	//GetPanelEventRect(eventData2, &cRect);
	
	GetPanelAttribute(mainPanel, ATTR_TOP, &attr_main_top);
	GetPanelAttribute(mainPanel, ATTR_WIDTH, &attr_main_width);
	GetPanelAttribute(mainPanel, ATTR_LEFT, &attr_main_left);	

	GetPanelAttribute(tpanel, ATTR_LEFT, &attr_left);
	GetPanelAttribute(tpanel, ATTR_WIDTH, &attr_width);
	GetPanelAttribute(tpanel, ATTR_TOP, &attr_top);
	//attr_left=cRect.left;
	//attr_width=cRect.width;
	//attr_top=cRect.top;
	
	attr_main_right=attr_main_width+attr_main_left+7;
	attr_right=attr_width+attr_left+7;
	
	magnet_region=50;
	
	if((attr_main_left<attr_left)&&(attr_main_right+magnet_region > attr_left))
		SetPanelAttribute(tpanel, ATTR_LEFT, attr_main_right);
	else if((attr_left<attr_main_left)&&(attr_right+magnet_region > attr_main_left))	
		SetPanelAttribute(tpanel, ATTR_LEFT, attr_main_left-attr_width-7);
	
	if((attr_main_top+magnet_region>attr_top)&&(attr_main_top-magnet_region<attr_top))
		SetPanelAttribute(tpanel,ATTR_TOP, attr_main_top);
	
	return 1;
}

