#include <userint.h>
#include "runtime.h"
#include <utility.h>
#include "FISS.h"
#include "CCD.h"
#include "scanner.h"
#include "Atmcd32d.h"
#include "TalkClientDLL.h"



HINSTANCE h_PmacLib = NULL; 	//DEFINE HANDLE(ڵ )  
BOOL bDriverOpen  = FALSE;  	//WHETHER PMAC IS OPEN OR NOT  
DWORD dwDevice = 0;				//DEVICE ADDRESS(ġ ּ ) 


//char str[256];//,vs[30],ds[30];	//STRING ARRAY 
double position=0;				//CURRENT POSITION OF A MOTOR
float step_size=0; 				//GLOBAL VARIABLE FOR A STEP SIZE
int PmacAccessible=0;			//1 IF bDriverOpen=1   
int Scanning=0;  			//WHETHER MOTOR IS RUNNING OR NOT ( )  
//int take=0;//, both_move=0; 					//NEED TO SYNCHRONIZE BETWEEN CCD AND SCANNER
								//1 IF SYNCHRONIZATION


int			plotHandle;  		//NEED TO REFRESH GRAPH


extern int mainPanel;
extern int scan_mode;
extern char ccd_path[256];		//Use Script Path(need to scanner CMD_RUN)
extern int 	zerostep; 

int g_nAmpOnSeq = 0; 


int Scanner_status=-1;			// -1:not operate, 0:turn off, 1:turn on
int Scanner_InPosition;			//whether motor is locate at home position or not
extern int take;





//associate with CCD frame;
//int		framecount;				//define this paramter to apply data dump for allocated memory      
//int		framecount_scancount;
int				Scanpos_CCDframe;
float			scanpos;
//extern int 		g_nFrameNumber1;
extern long 	nCameraHandle1,nCameraHandle2;
extern int 		nhDim1,nvDim1,nhDim2,nvDim2;
//extern float 	g_fExpTime1;



char kk[50];
void strreverse(char* begin, char* end) ;
void itoa(int value, char* str, int base);






//-----------------------------------------------
//need to make function ;; associate cvi pannel
//STEP 1. ESTABLISH A LINK WITH PMAC (PMAC Ʈѷ OPENϰ ʿ   ʱȭ) 

int ScanOpen(void)
{
	char strTemp[255],vs[30],ds[30];
	char str[255];
	
	
	RunLink();   
	bDriverOpen  = DeviceOpen(dwDevice);//OPEN PMAC

	
	
		
	if (bDriverOpen)
	{   //Print string 'Device is opened' 
		
		sprintf(str,"Device is opened in device #%d",bDriverOpen);
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, str);	
		 
				
		//Get Pmac info & print
		DeviceGetRomVersion(dwDevice,vs,30);
		DeviceGetRomDate(dwDevice,ds,30); 
		sprintf(str,TEXT("\nV%s %s"), vs,ds);
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, str);	
				
		//Set environment parameters & display the result
		DeviceGetResponse( dwDevice, strTemp, 255, "i900=3");
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
		DeviceGetResponse( dwDevice, strTemp, 255, "i125=$80C000");
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
		DeviceGetResponse( dwDevice, strTemp, 255, "i117=0.5");   				
		DeviceGetResponse( dwDevice, strTemp, 255, "i130=40000");   				
		DeviceGetResponse( dwDevice, strTemp, 255, "i131=1800");   				
		DeviceGetResponse( dwDevice, strTemp, 255, "i132=1800");   				
		DeviceGetResponse( dwDevice, strTemp, 255, "i133=40000");   				
		DeviceGetResponse( dwDevice, strTemp, 255, "i135=0");   				
				
		DeviceGetResponse( dwDevice, strTemp, 255,"i900");
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\ni900="); 
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
		DeviceGetResponse( dwDevice, strTemp, 255,"i125");
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "i125=");
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
		
//		DeviceGetResponse(dwDevice, strTemp, 255,"/a");
//		DeviceGetResponse(dwDevice, strTemp, 255,"j-");
//		DeviceGetResponse(dwDevice, strTemp, 255,"hm");
		

		//Read CURRENT position
		PmacAccessible=1;
		Scanner_status=1; //turn on scanner
		
	}
	
	else
	{
		sprintf(str,"Device is NOT opened! %d \n " ,bDriverOpen);
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, str);
		return 0;
	}
	
	return 1;
	
	
	
}


	
	
//STEP 2. TURNING ON THE MOTOR AMP (Ϳ  ΰѴ.)   
void ampon_timer(void)
{
	char strTemp[255];
	char strTemp2[255];

	char target[255];
	switch(g_nAmpOnSeq)
	{
		case 0:
		// ΰ
			DeviceGetResponse( dwDevice, strTemp, 255,"#1o0");
			DeviceGetResponse( dwDevice, strTemp, 255,"#1j/");  		 //positive limit?
						
			Delay(0.1);
			
			//AMP۵  Ȯ
			DeviceGetResponse( dwDevice, strTemp, 255,"m139->Y:$814,14");  
			DeviceGetResponse( dwDevice, strTemp, 255,"m138->X:$3D,18");   
			DeviceGetResponse( dwDevice, strTemp, 255,"m139");
			DeviceGetResponse( dwDevice, strTemp2, 255,"m138");  
			
			if ( *strTemp=='0' || *strTemp2=='1') 
			{
				SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 0); 	  //timer off
	           	sprintf(strTemp, "Amp is not powered."); 
	           	//MessageBox(NULL, strTemp, "Error", MB_OK | MB_ICONINFORMATION);
				break;
			}			  
			else
			{
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "Amp is turned ON\n");    
			}
			
			DeviceGetResponse( dwDevice, strTemp, 255,"m132->X:$3D,22"); 
			DeviceGetResponse( dwDevice, strTemp, 255,"j-"); 				//negative limit
						
			g_nAmpOnSeq = 10;
			break;
						
		case 10:
			DeviceGetResponse( dwDevice, strTemp, 255,"m132");
			if( *strTemp!='0' )
			{											  
				//DeviceGetResponse( dwDevice, strTemp, 255,"#1j/"); 
				Delay(1.0);
				DeviceGetResponse( dwDevice, strTemp, 255,"hm");   //homing
				g_nAmpOnSeq = 20;
				break;
			}
			break;

						
		case 20:
			DeviceGetResponse( dwDevice, strTemp, 255,"m145->Y:$814,10");
			g_nAmpOnSeq = 21;
			break;
		case 21:
			DeviceGetResponse( dwDevice, strTemp, 255,"m145");	
			if( *strTemp!='0')
			{
				 
				g_nAmpOnSeq = 22;
				break;
			}
			break;
		
		case 22:
			 ////////////////////////////////////////////////
			DeviceGetResponse( dwDevice, strTemp, 255,"m140");	
			if( *strTemp!='0')
			{		
				zerostep+=75000;
				sprintf(target,"#1J=%d",zerostep);
				DeviceGetResponse(dwDevice, strTemp, 255, target);
				g_nAmpOnSeq = 23;
				break;
			}
			break;
		case 23:
			DeviceGetResponse( dwDevice, strTemp, 255,"m140");	
			if( *strTemp!='0')
			{
				getresponse("HMZ");
				zerostep=0;
				g_nAmpOnSeq =30;
				break;
			}
			break;
		case 30:
			SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 0); 		 //timer off
			break;
				
	}
}




void ScanCommandWrite(int number, float duration, float size, float speed, float stroke)
{
	//extern char ccd_path[256];
	char Buff1[300]="fiss.head";
	char Buff2[300]="fiss.tail";
	char Buff[300]="FISS.pmc";

	char *Script1;
	char *Script2;
	unsigned n_byte1;
	unsigned n_byte2;
	int i;
	
	FILE *fp1;
	FILE *fp2;
	FILE *fp3;

	
	if((fp1=fopen(Buff1, "rb")) != NULL && (fp2=fopen(Buff2, "rb")) != NULL) 
	{
    	fseek(fp1, 0, SEEK_END);
    	n_byte1 = ftell( fp1 );
    	Script1 = (char *)malloc( n_byte1+1 );
		fseek(fp1, 0, SEEK_SET);
    	fread(Script1, n_byte1, 1, fp1);
		Script1[n_byte1] = 0;
		fclose(fp1); 

		fseek(fp2, 0, SEEK_END);
    	n_byte2 = ftell( fp2 );
    	Script2 = (char *)malloc( n_byte2+1 );
		fseek(fp2, 0, SEEK_SET);
    	fread(Script2, n_byte2, 1, fp2);
    	Script2[n_byte2] = 0;
		fclose(fp2);    

		fp3 = fopen( Buff, "wb");
    	fwrite(Script1, n_byte1, 1, fp3);
		fputs("\r\n", fp3); 


		if( (speed == 0.) && (stroke == 0))	//spectrograph mode
		{
				step_size=size;
				fprintf(fp3, "i130=120000\r\ni131=4000\r\ni132=4000\r\ni133=40000\r\ni134=0\r\ni135=20000\r\ninc\r\nta%3.f\r\nts%3.f\r\np1=0\r\nWhile(p1<%4d)\r\nx%4.f\r\ndwell%3.f\r\np1=p1+1\r\nEndWhile\r\n"
							, 0.350*duration, 0.170*duration, number, size, 0.300*duration);
		}
		
		if((duration == 0) && (size == 0))  //imaging mode
		{
				step_size=stroke/(float)number;
				fprintf(fp3, "i130=40000\r\ni131=1800\r\ni132=1800\r\ni133=40000\r\ni134=0\r\ni135=0\r\nabs\r\nta100\r\nts50\r\nf%2.f\r\nx%5.f\r\n", speed, stroke);			
		}
		
		
		fputs("\r\n", fp3); 
		fwrite(Script2, n_byte2, 1, fp3); 
		fclose(fp3);
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nScript was generated.\n");  
	}
			
	OpenScript(Buff); 	
	free(Script1);
	free(Script2);
}




int ExecuteProgram(long camera, int takemode)
{
	char response[255];
	long y;
	UINT maxchar=100;
	long numchar=0;
	int ptemp=0, p1=0;
	char temp1[50], temp2[50], temp3[250];
	float difftime1;
	int prevp1=-1;

			
			if(DeviceSetQuickGather(dwDevice, GATHER_COM1|GATHER_ENC1|GATHER_DAC1, TRUE)==FALSE )
			{
				MessageBox(NULL, "Set gathering failed.", "Error", MB_OK | MB_ICONINFORMATION); 
				return 0;
			}
			DeviceGetResponse(dwDevice, response, 255, "I19=5");// Data Gathering Selection Mask  ( I21 ~ I44  شϴ 24 Source  Mask Bit  )
			DeviceGetResponse(dwDevice, response, 255, "I20=7");						// I21,22,23 ҽ Gatheringϵ 
			DeviceGetResponse(dwDevice, response, 255, "CLOSE"); 
			DeviceGetResponse(dwDevice, response, 255, "END GAT");
			DeviceGetResponse(dwDevice, response, 255, "DEL GAT");
			DeviceGetResponse(dwDevice, response, 255, "DEF GAT");
			DeviceGetResponse( dwDevice, response, 255, "GAT &1 b1 r");
			DeviceGetResponse( dwDevice, response, 255,"m180->X:$818,0");   
			DeviceGetResponse( dwDevice, response, 255,"m145->Y:$814,10");   			
				
													  
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nStarting Scan.\n");  
			Scanning=1; 
 
			
			//framecount=0;
			

			while(1)
			{
				DeviceGetResponse( dwDevice, response, 255, "m180");
				if (*response=='0') 
				{
					Scanning=0;
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nScanning complete.\n"); 
					break;
				}
				
				switch(scan_mode)
				{
					case 0:
						DeviceGetResponse( dwDevice, response, 255, "p1"); 
						SetCtrlVal(mainPanel, PANEL_P1,response) ;
						p1=atoi(response); 
						
						
						if ((p1-ptemp)>0 && (position - (double)p1*(double)step_size*10) >=0 ) 
						{
							if(prevp1!=p1){
								Scanpos_CCDframe=p1;
								Lan_take(take, Scanpos_CCDframe);
								take=1;
								prevp1=p1;
								
							}
							
						}
						
						
						break;
					
					case 1:
						sprintf(response, "%d", p1);
						SetCtrlVal(mainPanel, PANEL_P1, response);
						p1=atoi(response);
	
						if (position - (double)p1*(double)step_size*10 >=(double)step_size*5 )
						{	
							p1++;
							Scanpos_CCDframe=p1;
							marktime_start(temp1);
							Lan_take(take, Scanpos_CCDframe);  
							take=1;
							marktime_end(temp2);
							difftime1=time_difference();
							
								
							

						}
						break;
				}
				
			}

	return 1;
}






void getresponse(char *string)
{
	char strTemp[255];
	DeviceGetResponse( dwDevice, strTemp, 255,string);
	SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
}
//------------------------------------------------









//TURN OFF SCANNER
void CloseDevice(void)
{
	char str[255];
	PmacAccessible=0;	//end of Thread
	if (bDriverOpen)
	{
		bDriverOpen  = !DeviceClose(dwDevice); 
		sprintf(str,"Device is Closed! %d \n ",bDriverOpen);
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, str);
	}
	
    if (h_PmacLib)
	{
		FreeLibrary(h_PmacLib);//FREEING HANDLE
		h_PmacLib = NULL;
	}
	
	Scanner_status=0; //turn off scanner
}



//ĳʰ ϴµ ־ ʿ dll ȭϰ,   Լ ε.
void RunLink(void)   
{ 
	h_PmacLib = LoadLibrary("PComm32.dll"); 
	DeviceOpen =(OPENPMACDEVICE)GetProcAddress(h_PmacLib,"OpenPmacDevice");
	DeviceClose =(CLOSEPMACDEVICE)GetProcAddress(h_PmacLib,"ClosePmacDevice");
	DeviceGetRomVersion = (GETROMVERSIONA)GetProcAddress(h_PmacLib,"PmacGetRomVersionA");
	DeviceGetRomDate = (GETROMDATEA)GetProcAddress(h_PmacLib,"PmacGetRomDateA");  
	DeviceGetResponse = (GETRESPONSEA)GetProcAddress(h_PmacLib,"PmacGetResponseA");
	DeviceDownload = (DOWNLOADA)GetProcAddress(h_PmacLib, "PmacDownloadA");
	DeviceGetBuffer = (GETBUFFERA)GetProcAddress(h_PmacLib, "PmacGetBufferA");	
	DeviceSetQuickGather = (SETQUICKGATHER)GetProcAddress(h_PmacLib,"PmacSetQuickGather"); 
	DeviceCollectGatherData = (COLLECTGATHERDATA)GetProcAddress(h_PmacLib,"PmacCollectGatherData");
	DeviceGetGatherSamples = (GETGATHERSAMPLES)GetProcAddress(h_PmacLib, "PmacGetGatherSamples"); 	  
	DeviceGetIVariableLong = (GETIVARIABLELONG)GetProcAddress(h_PmacLib, "PmacGetIVariableLong");   
	Delay(1);
}



//OPENING A CONTROL PROGRAM SCRIPT AND DOWNDOADING TO A BUFFER (ռ ۼ Ʈ α׷ PMAC  ۿ ε Ѵ.)
int OpenScript(char *filename)
{
    static FILE *fp;
	BOOL macro=TRUE;
	BOOL map=TRUE;
	BOOL log=TRUE;
	BOOL dnld=TRUE;
	long result;
	

    // 1.  open
    if((fp=fopen(filename, "rt")) == NULL)
		return 0;
	
	fclose(fp);
	
	Delay(1);			  						
	result=DeviceDownload(dwDevice, NULL, NULL, NULL, filename, macro, map, log, dnld);  //DOWNLOAD (PCHAR)
	Delay(1);
	if(result != 0){
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nDevice Download Success\n");  		//DISPLAY RESULT
		SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nOpen Script() called complete!!\n");  		//DISPLAY RESULT
		
	}

    return 0;
} 



//DISABLE POWER AND DISABLE MOTOR
int KillMotor(void)
{
	char strTemp[250]; 

			DeviceGetResponse( dwDevice, strTemp, 255, "#1k");  
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, strTemp); 
	
	return 1;
}





//READ AN ENCORDER POSITION (  ġ ڴ ȣκ ۹)
void ReadPosition(void)
{

	char strTemp[250];	
//	DeviceGetResponse( dwDevice, strTemp, 255, "m101");
	DeviceGetResponse( dwDevice, strTemp, 255, "#1P");
	position=atof(strTemp);
	scanpos=position/10;
	sprintf(strTemp, "%.1f", position/10.);
	SetCtrlVal(mainPanel, PANEL_Position, strTemp);    

	
//	position=atoi(strTemp);
}


//DISPLAY SCANNER CONDITION
void Monitor(void)
{
	char strTemp[250];
	int ampenable=0, inposition=0, ampfaulterr=0, motorrun=0, plimit=0, nlimit=0, openloop=0;
	
//	DeviceGetResponse( dwDevice, strTemp, 255, "m139");
//	ampenable=atoi(strTemp);	
	DeviceGetResponse( dwDevice, strTemp, 255, "m140");
	inposition=atoi(strTemp);
	Scanner_InPosition=inposition;
	DeviceGetResponse( dwDevice, strTemp, 255, "m137");
	motorrun=atoi(strTemp);
//	DeviceGetResponse( dwDevice, strTemp, 255, "m143");
//	ampfaulterr=atoi(strTemp);
	DeviceGetResponse( dwDevice, strTemp, 255, "m131");
	plimit=atoi(strTemp);
	DeviceGetResponse( dwDevice, strTemp, 255, "m132");
	nlimit=atoi(strTemp);
//	DeviceGetResponse( dwDevice, strTemp, 255, "m138");
//	openloop=atoi(strTemp);	
	
	//display motor status(by lamp)
//	SetCtrlVal(mainPanel, PANEL_AMPON, ampenable);   
	SetCtrlVal(mainPanel, PANEL_INPOSITION, inposition);
	SetCtrlVal(mainPanel, PANEL_MOTORRUN, motorrun);
//	SetCtrlVal(mainPanel, PANEL_AMPFAULTERR, ampfaulterr);  
	SetCtrlVal(mainPanel, PANEL_PLIMIT, plimit);
	SetCtrlVal(mainPanel, PANEL_NLIMIT, nlimit); 
//	SetCtrlVal(mainPanel, PANEL_OPENLOOP, openloop); 
}





//GATHERING-RELATED FUNCTION(  ͸ Դ  ׷ Ѵ.)  
BOOL UploadQuickGather(BOOL bSaveFile)
{
	
	CHAR response[256] = "";
	int i;
	long nMotor;
	UINT nNumSources, nNumSamples;
	long Ix08;
	double dSFactor0, dSFactor1, dSFactor2;		// о   Scale Factor
	double *pRdData0, *pRdData1, *pRdData2;
	double	*m_pGatData0;
	double	*m_pGatData1;
	double	*m_pGatData2;
	double  *m_pGatTime;//put for x axis drawing

	nMotor = 1;		// 1 Ϳ ؼ ϿǷ...

	// Data Gathering Source  Sample  ´.
	//  Լ  "LIST GAT"  Gathering ͸  ɴϴ.
	if ( DeviceCollectGatherData(dwDevice, &nNumSources, &nNumSamples)==FALSE )
		return FALSE;

	m_pGatData0 = (double *)calloc (nNumSamples, sizeof(double)); 
	m_pGatData1 = (double *)calloc (nNumSamples, sizeof(double));   
	m_pGatData2 = (double *)calloc (nNumSamples, sizeof(double)); 
	m_pGatTime  = (double *)calloc (nNumSamples, sizeof(double));
	pRdData0	= (double *)calloc (nNumSamples, sizeof(double));   
	pRdData1	= (double *)calloc (nNumSamples, sizeof(double));   
	pRdData2	= (double *)calloc (nNumSamples, sizeof(double));   

	
	// ̹ Gathering Ϳ  ش Source  ͸ nNumSamples ŭ ɴϴ.
	if ( DeviceGetGatherSamples(dwDevice, 0, &nNumSamples, pRdData0, nNumSamples)==FALSE )	// ù° ҽ شϴ ͸ ɴϴ.
		goto error_ret;
	if ( DeviceGetGatherSamples(dwDevice, 1, &nNumSamples, pRdData1, nNumSamples)==FALSE )	// ι° ҽ شϴ ͸ ɴϴ.
		goto error_ret;
	if ( DeviceGetGatherSamples(dwDevice, 2, &nNumSamples, pRdData2, nNumSamples)==FALSE )	// ° ҽ شϴ ͸ ɴϴ.
		goto error_ret;

	Ix08 = DeviceGetIVariableLong(dwDevice, nMotor*100+8, 96);	// Ix08 оͼ Scale ϴµ մϴ.

	dSFactor0 = 1.0/(Ix08*32.0);	// Commanded Position ( 1/(Ix08*32) cts )
	dSFactor1 = 1.0/(Ix08*32.0);	// Actual Position ( 1/(Ix08*32) cts )
	dSFactor2 = 1.0/256.0;			// DAC ( 1/256 )

	for ( i = 0; i<(int)nNumSamples; i++ )
	{
		m_pGatData0[i] = pRdData0[i] * dSFactor0;	// Commanded Pos	
		m_pGatData1[i] = pRdData1[i] * dSFactor1;	// Actual Pos
		m_pGatData2[i] = pRdData2[i] * dSFactor2;	// DAC Output
		m_pGatTime[i]= (float)i*5.*3703707./8388608./1000.;
		
	}
		
	//PLOT THE GATHERING RESULT IN A GRAPH (׷  Դ  )
	
	//RefreshGraph (mainPanel, Main_PANEL_GRAPH);
	
	if(plotHandle)
		DeleteGraphPlot(mainPanel, PANEL_GRAPH, plotHandle, VAL_IMMEDIATE_DRAW);
	PlotXY(mainPanel, PANEL_GRAPH, m_pGatTime, m_pGatData1, (int)nNumSamples, VAL_DOUBLE, VAL_DOUBLE, VAL_THIN_LINE, VAL_NO_POINT, VAL_SOLID, 1, VAL_RED); 
	
	if ( bSaveFile )
	{
		FILE *pfp;
		char chrFilename[50] = "GatherResult.txt";
		//char Buff[300]="FISS.pmc";  
		
		
		if ( (pfp=fopen(chrFilename, "wt+"))==NULL ){
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "FILE open fail"); 
			goto error_ret;
		}

		fprintf(pfp, "Quick Gathering Sample Data File\n");
		fprintf(pfp, "[Commanded Position]\t[Actual Position]\t[DAC Output]\n");

		for ( i = 0; i<(int)nNumSamples; i++ )																		
		{
			fprintf(pfp, "%20.3lf\t%20.3lf\t%20.3lf\t%20.3lf\n", m_pGatData0[i], m_pGatData1[i], m_pGatData2[i], m_pGatTime[i]);
		}

		fclose(pfp);
	}		

	free(pRdData0);
	free(pRdData1);
	free(pRdData2);
	
	free(m_pGatData0);
	free(m_pGatData1);
	free(m_pGatData2);
	free(m_pGatTime);
	
	return TRUE;

error_ret:
	free(pRdData0);
	free(pRdData1);
	free(pRdData2);
	
	free(m_pGatData0);
	free(m_pGatData1);
	free(m_pGatData2);
	free(m_pGatTime);	

	return FALSE;
}






//making itoa function
void strreverse(char* begin, char* end) 
{
		char aux;
		while(end>begin)
			aux=*end, *end--=*begin, *begin++=aux;
}


void itoa(int value, char* str, int base) 
{
		static char num[] = "0123456789abcdefghijklmnopqrstuvwxyz";
		char* wstr=str;
		int sign;
		div_t res;
	
		// Validate base
		if (base<2 || base>35){ *wstr='\0'; return; }
	
		// Take care of sign
		if ((sign=value) < 0) value = -value;
		// Conversion. Number is reversed.
		do 
		{
			res = div(value,base);
			*wstr++ = num[res.rem];
		}
		while(value=res.quot);
		
		if(sign<0) *wstr++='-';	*wstr='\0';
	
		// Reverse string
		strreverse(str,wstr-1);
}
	


